Bars.h
Go to the documentation of this file.
/**
* @file
* @brief Header file for Bars effect class
* @author Jonathan Thomas <jonathan@openshot.org>
*
* @ref License
*/
/* LICENSE
*
* Copyright (c) 2008-2019 OpenShot Studios, LLC
* <http://www.openshotstudios.com/>. This file is part of
* OpenShot Library (libopenshot), an open-source project dedicated to
* delivering high quality video editing and animation solutions to the
* world. For more information visit <http://www.openshot.org/>.
*
* OpenShot Library (libopenshot) is free software: you can redistribute it
* and/or modify it under the terms of the GNU Lesser General Public License
* as published by the Free Software Foundation, either version 3 of the
* License, or (at your option) any later version.
*
* OpenShot Library (libopenshot) is distributed in the hope that it will be
* useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public License
* along with OpenShot Library. If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef OPENSHOT_BARS_EFFECT_H
#define OPENSHOT_BARS_EFFECT_H
#include "../EffectBase.h"
#include <cmath>
#include <stdio.h>
#include <memory>
#include "../Color.h"
#include "../Json.h"
#include "../KeyFrame.h"
namespace openshot
{
/**
* @brief This class draws black bars around your video (from any side), and can be animated with
* openshot::Keyframe curves over time.
*
* Adding bars around your video can be done for cinematic reasons, and creates a fun way to frame
* in the focal point of a scene. The bars can be any color, and each side can be animated independently.
*/
class Bars : public EffectBase
{
private:
/// Init effect settings
void init_effect_details();
public:
Color color; ///< Color of bars
Keyframe left; ///< Size of left bar
Keyframe top; ///< Size of top bar
Keyframe right; ///< Size of right bar
Keyframe bottom; ///< Size of bottom bar
/// Blank constructor, useful when using Json to load the effect properties
Bars();
/// Default constructor, which takes 4 curves and a color. These curves animated the bars over time.
///
/// @param color The curve to adjust the color of bars
/// @param left The curve to adjust the left bar size (between 0 and 1)
/// @param top The curve to adjust the top bar size (between 0 and 1)
/// @param right The curve to adjust the right bar size (between 0 and 1)
/// @param bottom The curve to adjust the bottom bar size (between 0 and 1)
Bars(Color color, Keyframe left, Keyframe top, Keyframe right, Keyframe bottom);
/// @brief This method is required for all derived classes of EffectBase, and returns a
/// modified openshot::Frame object
///
/// The frame object is passed into this method, and a frame_number is passed in which
/// tells the effect which settings to use from its keyframes (starting at 1).
///
/// @returns The modified openshot::Frame object
/// @param frame The frame object that needs the effect applied to it
/// @param frame_number The frame number (starting at 1) of the effect on the timeline.
std::shared_ptr<Frame> GetFrame(std::shared_ptr<Frame> frame, int64_t frame_number);
/// Get and Set JSON methods
std::string Json() const override; ///< Generate JSON string of this object
void SetJson(const std::string value); ///< Load JSON string into this object
Json::Value JsonValue() const override; ///< Generate Json::Value for this object
void SetJsonValue(const Json::Value root); ///< Load Json::Value into this object
/// Get all properties for a specific frame (perfect for a UI to display the current state
/// of all properties at any time)
std::string PropertiesJSON(int64_t requested_frame) const override;
};
}
#endif
openshot::Bars
This class draws black bars around your video (from any side), and can be animated with openshot::Key...
Definition: Bars.h:55
openshot::Bars::SetJsonValue
void SetJsonValue(const Json::Value root)
Load Json::Value into this object.
Definition: Bars.cpp:157
openshot::Bars::PropertiesJSON
std::string PropertiesJSON(int64_t requested_frame) const override
Definition: Bars.cpp:176
openshot::Bars::right
Keyframe right
Size of right bar.
Definition: Bars.h:65
openshot::Bars::SetJson
void SetJson(const std::string value)
Load JSON string into this object.
Definition: Bars.cpp:140
openshot::Bars::top
Keyframe top
Size of top bar.
Definition: Bars.h:64
openshot::Bars::Json
std::string Json() const override
Get and Set JSON methods.
Definition: Bars.cpp:117
openshot::Bars::Bars
Bars()
Blank constructor, useful when using Json to load the effect properties.
Definition: Bars.cpp:36
openshot::Bars::GetFrame
std::shared_ptr< Frame > GetFrame(std::shared_ptr< Frame > frame, int64_t frame_number)
This method is required for all derived classes of EffectBase, and returns a modified openshot::Frame...
Definition: Bars.cpp:65
openshot::Bars::JsonValue
Json::Value JsonValue() const override
Generate Json::Value for this object.
Definition: Bars.cpp:124
openshot::Bars::bottom
Keyframe bottom
Size of bottom bar.
Definition: Bars.h:66
openshot::Bars::left
Keyframe left
Size of left bar.
Definition: Bars.h:63
openshot::Bars::color
Color color
Color of bars.
Definition: Bars.h:62
openshot::Color
This class represents a color (used on the timeline and clips)
Definition: Color.h:45
openshot::EffectBase
This abstract class is the base class, used by all effects in libopenshot.
Definition: EffectBase.h:67
openshot::Keyframe
A Keyframe is a collection of Point instances, which is used to vary a number or property over time.
Definition: KeyFrame.h:64
openshot
This namespace is the default namespace for all code in the openshot library.
Definition: AudioBufferSource.h:39